Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members

# SecretSharing Class Reference

`#include <ida.h>`

Inheritance diagram for SecretSharing:

List of all members.

## Detailed Description

a variant of Shamir's Secret Sharing Algorithm

Definition at line 56 of file ida.h.

## SIGNALS
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
virtual void | SetAutoSignalPropagation (int propagation)
| set propagation of automatically generated and transferred signals
virtual int | GetAutoSignalPropagation () const
## Public Member Functions
| SecretSharing (RandomNumberGenerator &rng, int threshold, int nShares, BufferedTransformation *attachment=NULL, bool addPadding=true)
void | IsolatedInitialize (const NameValuePairs &parameters=g_nullNameValuePairs)
unsigned int | Put2 (const byte *begin, unsigned int length, int messageEnd, bool blocking)
| input multiple bytes for blocking or non-blocking processing
bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
bool | Attachable ()
| returns whether this object allows attachment
BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
const BufferedTransformation * | AttachedTransformation () const
void | Detach (BufferedTransformation *newAttachment=NULL)
| delete the current attachment chain and replace it with newAttachment
unsigned int | TransferTo2 (BufferedTransformation &target, unsigned long &transferBytes, const std::string &channel=NULL_CHANNEL, bool blocking=true)
unsigned int | CopyRangeTo2 (BufferedTransformation &target, unsigned long &begin, unsigned long end=ULONG_MAX, const std::string &channel=NULL_CHANNEL, bool blocking=true) const
void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
BufferedTransformation & | Ref ()
| return a reference to this object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | Wait (unsigned long milliseconds)
| wait on this object
## Static Public Attributes
static const std::string | NULL_CHANNEL
## Protected Member Functions
virtual BufferedTransformation * | NewDefaultAttachment () const
void | Insert (Filter *nextFilter)
virtual bool | ShouldPropagateMessageEnd () const
virtual bool | ShouldPropagateMessageSeriesEnd () const
void | PropagateInitialize (const NameValuePairs &parameters, int propagation)
unsigned int | Output (int outputSite, const byte *inString, unsigned int length, int messageEnd, bool blocking, const std::string &channel=NULL_CHANNEL)
unsigned int | OutputModifiable (int outputSite, byte *inString, unsigned int length, int messageEnd, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputMessageEnd (int outputSite, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputFlush (int outputSite, bool hardFlush, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputMessageSeriesEnd (int outputSite, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
## Static Protected Member Functions
static int | DecrementPropagation (int propagation)
## Protected Attributes
RandomNumberGenerator & | m_rng
RawIDA | m_ida
bool | m_pad
unsigned int | m_inputPosition
int | m_continueAt

## Member Function Documentation

unsigned int SecretSharing::Put2 | ( | const byte * | begin,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[virtual]`

  | input multiple bytes for blocking or non-blocking processing Parameters:
  | messageEnd | means how many filters to signal MessageEnd to, including this one
Implements BufferedTransformation.

bool SecretSharing::Flush | ( | bool | hardFlush,
|  | int | propagation = `-1`,
|  | bool | blocking = `true`
| ) | `[inline, virtual]`

  | flush buffered input and/or output Parameters:
  | hardFlush | is used to indicate whether all data should be flushed
Note: Hard flushes must be used with care. It means try to process and output everything, even if there may not be enough data to complete the action. For example, hard flushing a HexDecoder would cause an error if you do it after inputing an odd number of hex encoded characters. For some types of filters, for example ZlibDecompressor, hard flushes can only be done at "synchronization points". These synchronization points are positions in the data stream that are created by hard flushes on the corresponding reverse filters, in this example ZlibCompressor. This is useful when zlib compressed data is moved across a network in packets and compression state is preserved across packets, as in the ssh2 protocol. Implements CustomFlushPropagation< Filter >. Definition at line 68 of file ida.h. References Unflushable< T >::Flush(), and m_ida.

bool Filter::Attachable | ( |  | ) | `[inline, virtual, inherited]`

| returns whether this object allows attachment Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed. Reimplemented from BufferedTransformation. Definition at line 19 of file filters.h.

bool Filter::MessageSeriesEnd | ( | int | propagation = `-1`,
|  | bool | blocking = `true`
| ) | `[virtual, inherited]`

| mark end of a series of messages There should be a MessageEnd immediately before MessageSeriesEnd. Reimplemented from BufferedTransformation. Reimplemented in Multichannel< Filter >. Definition at line 82 of file filters.cpp. References BufferedTransformation::IsolatedMessageSeriesEnd(), Filter::m_continueAt, Filter::OutputMessageSeriesEnd(), and Filter::ShouldPropagateMessageSeriesEnd().

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline, inherited]`

| return a reference to this object This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference. Definition at line 711 of file cryptlib.h.

virtual byte* BufferedTransformation::CreatePutSpace | ( | unsigned int & | size | ) | `[inline, virtual, inherited]`

| request space which can be written into by the caller, and then used as input to Put() Note: The purpose of this method is to help avoid doing extra memory allocations. Reimplemented in MeterFilter, HashFilter, Redirector, OutputProxy, ArraySink, ArrayXorSink, ByteQueue, Multichannel< Filter >, and Multichannel< Sink >. Definition at line 730 of file cryptlib.h. Referenced by BufferedTransformation::ChannelCreatePutSpace(), and ArrayXorSink::CreatePutSpace().

virtual unsigned int BufferedTransformation::PutModifiable2 | ( | byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

  | input multiple bytes that may be modified by callee for blocking or non-blocking processing Parameters:
  | messageEnd | means how many filters to signal MessageEnd to, including this one
Reimplemented in MeterFilter, FilterWithBufferedInput, OutputProxy, Multichannel< Filter >, and Multichannel< Sink >. Definition at line 748 of file cryptlib.h. Referenced by BufferedTransformation::ChannelPutModifiable2(), NetworkSource::GeneralPump2(), and Filter::OutputModifiable().

virtual void BufferedTransformation::SetAutoSignalPropagation | ( | int | propagation | ) | `[inline, virtual, inherited]`

| set propagation of automatically generated and transferred signals propagation == 0 means do not automaticly generate signals Reimplemented in SourceTemplate< T >, SourceTemplate< FileStore >, SourceTemplate< RandomNumberStore >, SourceTemplate< StringStore >, AutoSignaling< BufferedTransformation >, AutoSignaling< InputRejecting< BufferedTransformation > >, AutoSignaling< Filter >, AutoSignaling< Source >, and AutoSignaling< Unflushable< Multichannel< Filter > > >. Definition at line 788 of file cryptlib.h.

unsigned long BufferedTransformation::MaxRetrievable | ( |  | ) | const`[virtual, inherited]`

| returns number of bytes that is currently ready for retrieval All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable(). Reimplemented in FileStore, RandomNumberStore, NullStore, MessageQueue, ByteQueue, ByteQueue::Walker, and RandomPool. Definition at line 247 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation(), BufferedTransformation::CopyTo(), and BufferedTransformation::MaxRetrievable(). Referenced by RandomNumberStore::AnyRetrievable(), Integer::BERDecode(), Integer::Decode(), DL_GroupParameters_EC< EC >::Initialize(), BufferedTransformation::MaxRetrievable(), EcRecommendedParameters< ECP >::NewEC(), EcRecommendedParameters< EC2N >::NewEC(), Integer::OpenPGPDecode(), and BufferedTransformation::TotalBytesRetrievable().

bool BufferedTransformation::GetNextMessage | ( |  | ) | `[virtual, inherited]`

| start retrieving the next message Returns false if no more messages exist or this message is not completely retrieved. Reimplemented in MessageQueue, and Store. Definition at line 336 of file cryptlib.cpp. References BufferedTransformation::AnyMessages(), BufferedTransformation::AttachedTransformation(), and BufferedTransformation::GetNextMessage(). Referenced by BufferedTransformation::GetNextMessage(), and BufferedTransformation::TransferMessagesTo2().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 321 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

The documentation for this class was generated from the following file:

- ida.h